<template>
  <div class="mt-10 mb-20">
    <!-- Formulaire nouveau projet -->
    <form @submit="newProject">
      <div class="flex">
        <!-- Formulaire > nom du projet -->
        <div>
          <p class="py-2 text-lg">Nom du projet</p>
          <label>
            <input v-model="projectName" type="text" required min="6" maxlength="40" placeholder="Mon projet secret" class="w-64 p-1 border-2 rounded border-gray-300">
          </label>
        </div>
        <!-- Photo du projet // WORK IN PROGRESS -->
        <div class="ml-14 w-28 h-28 rounded-full border-2 border-yellow-600">
          <!-- To do : créer l'image -->
          <div class="flex justify-center items-center w-28 h-28 text-center">
            <p class="text-gray-300">Photo du projet</p>
          </div>
        </div>
      </div>
      <!-- Formulaire > déscription du projet -->
      <div class="mt-4">
        <p class="py-2 text-lg">Déscription</p>
        <label>
          <textarea v-model="projectDescription" cols="60" rows="5" required placeholder="..." class="p-1 border-2 rounded border-gray-300"></textarea>
        </label>
      </div>
      <div class="flex">
        <!-- Formulaire > visibilité -->
        <div>
          <p class="py-2 text-lg">Visibilité</p>
          <label>
            <select v-model="visibility" name="visibility" id="visibility" class="p-1 border-2 rounded border-gray-300">
              <option value="true" selected>Public</option>
              <option value="false">Private</option>
            </select>
          </label>
        </div>
        <!-- Formulaire > statut -->
        <div class="ml-14">
          <p class="py-2 text-lg">Statut</p>
          <label>
            <select v-model="statut" name="statut" id="statut" class="p-1 border-2 rounded border-gray-300">
              <option value="progress" selected>En cours</option>
              <option value="pause">En pause</option>
              <option value="finish">Terminé</option>
            </select>
          </label>
        </div>
      </div>
      <!-- Formulaire > bouton -->
      <input type="submit" value="Créer" class="px-2 py-1 mt-7 bg-white border-2 border-yellow-600 rounded transition duration-300 hover:text-white hover:bg-yellow-600">
    </form>
    <!-- Formulaire > erreur -->
    <div v-if="error" class="m-auto mt-5 w-3/4 text-center text-red-600">
      <p>{{ error }}</p>
    </div>
  </div>
</template>

<script>
import { db } from '@/main'
export default {
  name: 'NewProject',
  props: {
    currentUser: {},
    switchCurrentComponent: Function
  },
  data: () => ({
    projectName: '',
    projectDescription: '',
    visibility: '',
    statut: '',
    error: null,
  }),
  methods: {
    redirectToMyProjectsComp() {
      this.switchCurrentComponent('MyProjects')
    },
    // Fctn pour créer un nouveau projet
    async newProject() {
      try {
        await db.collection('projects').add({
          uid: this.currentUser.id,
          uName: this.currentUser.name,
          projectName: this.projectName,
          projectDescription: this.projectDescription,
          projectVisibility: this.visibility,
          projectStatut: this.statut,
          createdAt: new Date()
        })
        this.redirectToMyProjectsComp()
        console.log('newProject : new project success') // TO CLEAN
      }
      catch (err) {
        console.log('newProject : new project error') // TO CLEAN
        this.error = err
        console.log(`Project error: ${err}`)
      }
    }
  }
}
</script>
